<?php


###################################################
# Contact ------> streaker69@comcast.net	  #
# Program ------> XMLPort for Cacti		  #
# Version ------> 0.3.5				  #
# Purpose ------> To rapidly export all templates #
# to a local directory on the Cacti Server	  #
###################################################


function plugin_init_xmlport() {
	global $plugin_hooks;
        $plugin_hooks['top_header_tabs']['xmlport'] = 'xmlport_show_tab';
        /* $plugin_hooks['top_graph_header_tabs']['xmlport'] = 'xmlport_show_tab'; */
        $plugin_hooks['config_arrays']['xmlport'] = 'xmlport_config_arrays';
	$plugin_hooks['config_settings']['xmlport'] = 'xmlport_config_settings';
        $plugin_hooks['draw_navigation_text']['xmlport'] = 'xmlport_draw_navigation_text';
}

function xmlport_config_settings () {
        global $tabs, $settings;
        $tabs["misc"] = "Misc";

        $temp = array(
                "xmlport_header" => array(
                        "friendly_name" => "XMLPort",
                        "method" => "spacer",
                        ),
                "xmlport_zip" => array(
                        "friendly_name" => "Location of Zip.php",
                        "description" => "The full file path to Pear's Zip.php file.",
                        "method" => "filepath",
                        "max_length" => 255,
                        ),
                "xmlport_tar" => array(
                        "friendly_name" => "Location of Tar.php",
                        "description" => "The full file path to Pear's Tar.php file.",
                        "method" => "filepath",
                        "max_length" => 255,
                        )
        );
        if (isset($settings["misc"]))
                $settings["misc"] = array_merge($settings["misc"], $temp);
        else
                $settings["misc"]=$temp;
}




/* function xmlport_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('xmlport.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('xmlport.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		print '<a href="' . $config['url_path'] . 'plugins/xmlport/xmlport.php"><img src="' . $config['url_path'] . 'plugins/xmlport/images/tab_xmlport';
		if(preg_match('/plugins\/xmlport\/xmlport.php/',$_SERVER['REQUEST_URI'] ,$matches))
		{
			print "_down";
		}
		print '.gif" alt="xmlport" align="absmiddle" border="0"></a>';

	}
}
*/
function xmlport_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu;
	$user_auth_realms[142]='View XMLPort';
	$user_auth_realm_filenames['xmlport.php'] = 142;
	$user_auth_realm_filenames['xmlimport.php'] = 142;
	$user_auth_realm_filenames['xmlfile.php'] = 142;
	$user_auth_realm_filenames['xmlarchive.php'] = 142;
	$menu["Import/Export"]['plugins/xmlport/xmlport.php'] = "XMLPort";
}


function xmlport_draw_navigation_text ($nav) {
   $nav["xmlport.php:"] = array("title" => "XMLExport", "mapping" => "index.php:", "url" => "xmlport.php", "level" => "1");
   $nav["xmlimport.php:"] = array("title" => "XMLImport", "mapping" => "index.php:", "url" => "xmlimport.php", "level" => "1");
   $nav["xmlfile.php:save"] = array("title" => "XMLImport" , "mapping" => "index.php:", "url" => "xmlfile.php", "level" => "1");
   $nav["xmlarchive.php:"] = array("title" => "XMLArchive" , "mapping" => "index.php:" , "url" => "xmlarchive.php", "level" => "1");
   $nav["xmlarchive.php:save"] = array("title" => "XMLArchive" , "mapping" => "index.php:" , "url" => "xmlarchive.php", "level" => "1");
   return $nav;
}

function xmlport_version () {
	return array( 'name' 	=> 'XMLPort',
			'version' 	=> '0.3.5',
			'longname'	=> 'XMLPort',
			'author'	=> 'streaker69',
			'email'	=> 'streaker69@comcast.net',
			'homepage' => 'http://forums.cacti.net/viewtopic.php?t=27955',
			'url'	=> 'http://members.netjunkies.net/streaker/versions.php',
			);
}

?>
