<?php

chdir("../../");
include("./include/auth.php"); 
include_once("./lib/functions.php");
include_once("./include/global.php");
include_once("./include/top_header.php");

$ds_actions = array(
	1 => "Delete",
	);

/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }
	if ((strpos(read_config_option("xmlport_tar"),"Tar.php") != true) || (strpos(read_config_option("xmlport_zip"),"Zip.php")) != true) {
		print "<b><font color=red size=3>Error: Archive Path's not set in Settings</font></b><br><br>
		Please set the path to Tar.php and Zip.php on the Settings => Misc page before continuing.<br>
		If you do not have Tar.php and Zip.php installed, you can do so by running the following commands at the console:<br>
		pear install Archive_tar<br>
		pear install Archive_zip";
		exit;
	}

$export_types = array(
	"graph_template" => array(
		"name" => "Graph Template",
		"title_sql" => "select name from graph_templates where id=|id|",
		"dropdown_sql" => "select id,name from graph_templates order by name"
		),
	"data_template" => array(
		"name" => "Data Template",
		"title_sql" => "select name from data_template where id=|id|",
		"dropdown_sql" => "select id,name from data_template order by name"
		),
	"host_template" => array(
		"name" => "Host Template",
		"title_sql" => "select name from host_template where id=|id|",
		"dropdown_sql" => "select id,name from host_template order by name"
		),
	"data_query" => array(
		"name" => "Data Query",
		"title_sql" => "select name from snmp_query where id=|id|",
		"dropdown_sql" => "select id,name from snmp_query order by name"
		)
	);

switch ($_REQUEST["action"]) {
	case 'save':
		create_archive();

		break;
	default:
		menu_select();

		break;
}

function menu_select (){
		global $colors, $export_types;
	/* 'graph_template' should be the default */
	if (!isset($_REQUEST["export_type"])) {
		$_REQUEST["export_type"] = "graph_template";
	}
	?>
	<form name="form_graph_id">
	<table width='100%' style='background-color: #f5f5f5; border: 1px solid #bbbbbb;' align='center'>
		<tr bgcolor="<?php print $colors["light"];?>">
			<td class="textArea" style="padding: 3px;">
				What would you like to Archive?&nbsp;

				<select name="cbo_graph_id" onChange="window.location=document.form_graph_id.cbo_graph_id.options[document.form_graph_id.cbo_graph_id.selectedIndex].value">
					<?php
					while (list($key, $array) = each($export_types)) {
					print "<option value='xmlarchive.php?export_type=$key'"; if ($_REQUEST["export_type"] == $key) { print " selected"; } print ">" . $array["name"] . "</option>\n";
					}
					?>
				</select>
		<a href="xmlimport.php">File Importer</a>&nbsp;&nbsp;<a href="xmlport.php">File Exporter</a></td>
		</tr>
		
	</table>
	</form>
	<form method="post" action="xmlarchive.php">
<?php

	html_start_box("<strong>Available Archives</strong> [" . $export_types{$_REQUEST["export_type"]}["name"] . "]", "100%", $colors["header"], "3", "center", "");

	form_alternate_row_color($colors["form_alternate1"],$colors["form_alternate2"],0); ?>
		<tr><td><input type="radio" value="zip" name="atype" checked>Zip Archive	<input type="radio" value="tar.gz" name="atype">tar.gz Archive</td></tr>
		<td width="50%" valign="top">
			<font class="textEditTitle">Available <?php print $export_types{$_REQUEST["export_type"]}["name"];?> to download</font><br>
			
		</td>
		<td><?php
$dirpath = "./plugins/xmlport/archive";
$dh = opendir($dirpath);
while (false !== ($file = readdir($dh))) {
if (!is_dir("$dirpath/$file")) {
print "<a href=./archive/$file>" . $file. "</a>   " . filesize("$dirpath/$file") . "bytes  " . date("F d Y H:i:s.", filectime("$dirpath/$file")) . "<br>";
}
}
closedir($dh);

form_hidden_box("export_type", $_REQUEST["export_type"], "");
form_hidden_box("list", $_REQUEST["export_type"],"");
html_end_box(false);
form_save_button("xmlarchive.php:save");
}
function create_archive () {
	$tarpath = read_config_option("xmlport_tar");
	$zippath = read_config_option("xmlport_zip");
	include($tarpath);
	include($zippath);
	$name = $_REQUEST["export_type"];
	$listdir = "./plugins/xmlport/" . $_REQUEST["export_type"];
	exec("touch ./plugins/xmlport/archive/.test.txt");
	if (!file_exists("./plugins/xmlport/archive/.test.txt")) { 
		print "Archive Directory is not writable.";
		exit;
	}else{
		exec("rm -rf ./plugins/xmlport/archive/.test.txt");
	}
	$type = $_REQUEST["atype"];
	$files = array();
	if (is_dir($listdir)) {
	$fh = opendir($listdir);
	while (($file = readdir($fh)) !== false) {
      # loop through the files, skipping . and .., and recursing if necessary
      if (strcmp($file, '.')==0 || strcmp($file, '..')==0) continue;
      $filepath = $listdir . '/' . $file;
      if ( !is_dir($filepath) )
        array_push($files, $filepath);
	}
	if (count($files) > 0) {
        if ($type == 'zip' ) {
                $name = "./plugins/xmlport/archive/" . $name . ".zip";
		if (file_exists($name)) { unlink($name);}
		$mimetype = 'application/zip';
                $zipfile = New Archive_Zip($name);
                $zipfile->create($files);
        } else {
                $name = "./plugins/xmlport/archive/" . $name . ".tar.gz";
		if (file_exists($name)) { unlink($name);}
		$mimetype = 'application/x-tar-gz';
                $tarfile = New Archive_Tar($name, 'gz');
                $tarfile->create($files);
	}
			if (file_exists($name) == true) { 
			menu_select();
			}
	} else {
		menu_select();
	}
    closedir($fh);
  }
  	
}

?>
