<?php


chdir("../../");
include("./include/auth.php"); 
include_once("./lib/export.php");
include_once("./include/global.php");
include_once("./include/top_header.php");


/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }

$export_types = array(
	"graph_template" => array(
		"name" => "Graph Template",
		"title_sql" => "select name from graph_templates where id=|id|",
		"dropdown_sql" => "select id,name from graph_templates order by name"
		),
	"data_template" => array(
		"name" => "Data Template",
		"title_sql" => "select name from data_template where id=|id|",
		"dropdown_sql" => "select id,name from data_template order by name"
		),
	"host_template" => array(
		"name" => "Host Template",
		"title_sql" => "select name from host_template where id=|id|",
		"dropdown_sql" => "select id,name from host_template order by name"
		),
	"data_query" => array(
		"name" => "Data Query",
		"title_sql" => "select name from snmp_query where id=|id|",
		"dropdown_sql" => "select id,name from snmp_query order by name"
		)
	);

switch ($_REQUEST["action"]) {
	case 'save':
		form_save();

		break;
	default:
		export();

		break;
}

/* ---------------------------

    Template Export Functions
   --------------------------- */

function export() {

	global $colors, $export_types;

	/* 'graph_template' should be the default */
	if (!isset($_REQUEST["export_type"])) {
		$_REQUEST["export_type"] = "graph_template";
	}

	?>
	<form name="form_graph_id">
	<table width='100%' style='background-color: #f5f5f5; border: 1px solid #bbbbbb;' align='center'>
		<tr bgcolor="<?php print $colors["light"];?>">
			<td class="textArea" style="padding: 3px;">
				What would you like to export?&nbsp;

				<select name="cbo_graph_id" onChange="window.location=document.form_graph_id.cbo_graph_id.options[document.form_graph_id.cbo_graph_id.selectedIndex].value">
					<?php
					while (list($key, $array) = each($export_types)) {
						print "<option value='xmlport.php?export_type=$key'"; if ($_REQUEST["export_type"] == $key) { print " selected"; } print ">" . $array["name"] . "</option>\n";
						}
					?>
				</select>
		<a href="xmlimport.php">File Importer</a>&nbsp;&nbsp;<a href="xmlarchive.php">XML Archiver</a></td>
		</tr>
	</table>
	</form>
	<form method="post" action="xmlsave.php" target="_blank">
	<?php

	html_start_box("<strong>Export Template</strong> [" . $export_types{$_REQUEST["export_type"]}["name"] . "]", "100%", $colors["header"], "3", "center", "");

	form_alternate_row_color($colors["form_alternate1"],$colors["form_alternate2"],0); ?>
		<td width="50%" valign="top">
			<font class="textEditTitle">Available <?php print $export_types{$_REQUEST["export_type"]}["name"];?> to Export</font><br>
			
		</td>
		<td>
			<?php
			$sql = $export_types{$_REQUEST["export_type"]}["dropdown_sql"];
			$result=mysql_query($sql);
			while($row=mysql_fetch_array($result)){
			print  $row['name'] . "<br>";
	}
?>
		</td>
	</tr>

	<?php form_alternate_row_color($colors["form_alternate1"],$colors["form_alternate2"],1); ?>
		<td width="50%">
			<font class="textEditTitle">Include Dependencies</font><br>
			Some templates rely on other items in Cacti to function properly. It is highly recommended that you select
			this box or the resulting import may fail.
		</td>
		<td>
			<?php form_checkbox("include_deps", "on", "Include Dependencies", "on", "", true);?>
		</td>
	</tr>

		<?php	

	form_hidden_box("export_type", $_REQUEST["export_type"], "");
	form_hidden_box("sql", $export_types{$_REQUEST["export_type"]}["dropdown_sql"],"");
	form_hidden_box("title_sql", $export_types{$_REQUEST["export_type"]}["title_sql"],"");
	form_hidden_box("save_component_export","1","");

	html_end_box();

	form_save_button("xmlsave.php");
}
?>

